// AbortDocDemoDlg.h : header file
//

#pragma once

#include "ProgressDlg.h"

// CAbortDocDemoDlg dialog
class CAbortDocDemoDlg : public CDialog
{
// Construction
public:
	CAbortDocDemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_ABORTDOCDEMO_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

protected:
  HDC  StartPrintJob();
  void StartProgressDlg();
  void StartDocument(HDC const& hdc, DOCINFO const& di);
  void StartPage(HDC const& hdc);
  void Print(HDC const& hdc, int counter);
  void EndPage(HDC const& hdc);
  void EndDocument(HDC const& hdc);
  void EndProgressDlg();
  void EndPrintJob(HDC const& hdc);

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnBnClickedCancel2();
  CString m_strPrinter;
  afx_msg void OnBnClickedOk();
  int m_nPages;
  CProgressDlg m_dlgStop;
};
