// ProgressDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AbortDocDemo.h"
#include "ProgressDlg.h"


// CProgressDlg dialog

IMPLEMENT_DYNAMIC(CProgressDlg, CDialog)
CProgressDlg::CProgressDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProgressDlg::IDD, pParent)
  , m_bAborted(FALSE)

{
}

CProgressDlg::~CProgressDlg()
{
}

void CProgressDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_PROGRESS1, m_progress);
}


BEGIN_MESSAGE_MAP(CProgressDlg, CDialog)
  ON_BN_CLICKED(IDSTOP, OnBnClickedStop)
END_MESSAGE_MAP()


// CProgressDlg message handlers

BOOL CProgressDlg::PeekAndPump()
{
	static MSG msg;

	while (::PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)) {
		if (!AfxGetApp()->PumpMessage()) {
			::PostQuitMessage(0);
			return FALSE;
		}	
	}

	return TRUE;
}

void CProgressDlg::OnBnClickedStop()
{
  m_bAborted = TRUE;
  OnOK();
}

void CProgressDlg::SetCaption(CString str)
{
  SetWindowText(str);
  Invalidate();
}
