// MFCPrintDemoView.h : interface of the CMFCPrintDemoView class
//


#pragma once


class CMFCPrintDemoView : public CScrollView
{
protected: // create from serialization only
	CMFCPrintDemoView();
	DECLARE_DYNCREATE(CMFCPrintDemoView)

// Attributes
public:
	CMFCPrintDemoDoc* GetDocument() const;

// Operations
protected:
  CRect m_rectPrint;
  CSize m_sizePage;
  CSize m_sizePageScroll;
  CSize m_sizeLineScroll;

  void DrawRulers(CDC& dc);
  void DrawData(CDC& dc);

  // Overrides
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CMFCPrintDemoView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
};

#ifndef _DEBUG  // debug version in MFCPrintDemoView.cpp
inline CMFCPrintDemoDoc* CMFCPrintDemoView::GetDocument() const
   { return reinterpret_cast<CMFCPrintDemoDoc*>(m_pDocument); }
#endif

