// SetAbortProcDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SetAbortProcDemo.h"
#include "SetAbortProcDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSetAbortProcDemoDlg dialog



CSetAbortProcDemoDlg::CSetAbortProcDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetAbortProcDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSetAbortProcDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSetAbortProcDemoDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CSetAbortProcDemoDlg message handlers

BOOL CSetAbortProcDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSetAbortProcDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSetAbortProcDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSetAbortProcDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSetAbortProcDemoDlg::OnBnClickedOk()
{
  if (UpdateData())
  {
    try
    {
      HDC hdc = StartPrintJob();

      DOCINFO di;
      ZeroMemory(&di, sizeof(DOCINFO));
      di.cbSize = sizeof(DOCINFO);
      di.lpszDocName = "SetAbortProc Test";

      StartDocument(hdc, di);
      StartPage(hdc);

      SetAbortProc(hdc, &CSetAbortProcDemoDlg::Abort);  
      Print(hdc, 1);

      EndPage(hdc);
      EndDocument(hdc);
      EndPrintJob(hdc);
    }
    catch(char* pz)
    {
      AfxMessageBox(pz);
    }
  }
}

HDC CSetAbortProcDemoDlg::StartPrintJob()
{
  HDC hdc = ::CreateDC(_T("WINSPOOL"), 
                        _T("HP1170C"), 
                        NULL, 
                        NULL);
  if (!hdc)
  {
    throw "Could not acquire a printer dc. "
                 "Do you have a printer installed? "
                 "If so, check the name and make sure "
                 "you entered it correctly.";
  }

  return hdc;
}

void CSetAbortProcDemoDlg::StartDocument(HDC const& hdc, DOCINFO const& di)
{
  if (SP_ERROR == ::StartDoc(hdc,&di))
    throw "Could not start the printing process (::StartDoc).";
}

void CSetAbortProcDemoDlg::StartPage(HDC const& hdc)
{
  if (!::StartPage(hdc))
    throw "Error calling ::StartPage";
}

void CSetAbortProcDemoDlg::Print(HDC const& hdc, int counter)
{
  // Simulate getting data to print
  ::Sleep(1000);

  CString strText;
  strText.Format("Page %ld - AbortDoc Test",  counter);

  ::TextOut(hdc, 
            10, 10, 
            strText, 
            strText.GetLength());
}

void CSetAbortProcDemoDlg::EndPage(HDC const& hdc)
{
  if (!::EndPage(hdc))
    throw "Error calling::EndPage";
}

void CSetAbortProcDemoDlg::EndDocument(HDC const& hdc)
{
  if (!::EndDoc(hdc))
    throw "Error calling ::EndDoc";
}

void CSetAbortProcDemoDlg::EndPrintJob(HDC const& hdc)
{
  if (!::DeleteDC(hdc))
    throw "Error calling ::DeleteDC";
}

BOOL CSetAbortProcDemoDlg::Abort(HDC hdc,int iError)
{
  BOOL bContinuePrintJob = TRUE;

  TRACE1("[Abort] Code = %ld\n", iError);

  MSG Msg;

  while (!UserAbort 
  && PeekMessage(&Msg, NULL, O, O, PM_REMOVE))
  {
    TRACE("[Abort] In loop");
    TranslateMessage (&Msg);
    DispatchMessage (&Msg);
  }

  return bContinuePrintJob;
}
